import pygame
import yumenokaze
import vector2
import levels
import player
import ennemies
import bonus
import sys

black = 0, 0, 0
white = 255, 255, 255
magenta = 255, 0, 255

class World:
    def __init__(self, width=1024,height=768,debug=0):
        self.width = width
        self.height = height
        if self.width == 1024 and self.height == 768:
            self.res=1
            self.offsetx=-8
            #self.offsety=-20
            self.offsety=-0
            self.factorH=1
            self.factorV=1
            self.renderWidth=20
            self.renderHeight=20
        debug=0

        self.spriteList = []
        self.create()
        self.playercollide=pygame.sprite.Sprite()

    def create(self):
        self.map=levels.Level1Map(self.offsetx,self.offsety,self)
        #self.map.tileset.load(self.renderWidth,self.renderHeight)
        self.gravity=9.8
        #self.gravity=0

        #self.background=pygame.Surface((self.width,self.height-self.offset))
        self.background=pygame.Surface((self.width,self.height))
        self.background.fill(white)

        self.mapPos=vector2.Vector2(0,0)
        self.mapDraw=vector2.Vector2(0,0)

        # affichage de la map, a remplacer par les decors
        for j in range(39):
            for i in range(52):
                if self.debug: print int(self.mapPos.x)+i,int(self.mapPos.y)+j,i*self.renderWidth,j*self.renderHeight,self.map.mapData[int(self.mapPos.y)+j][int(self.mapPos.x)+i]
                #self.background.blit(self.map.tileset.tiles[self.map.mapData[int(self.mapPos.y)+j][int(self.mapPos.x)+i]],(i*self.renderWidth,j*self.renderHeight))
        for s in self.map.decors:
            self.background.blit(s.displayFrame(),s.rect)
            #print s.rect
        #screen.blit(self.background,(self.offsetx,self.offsety))
        #for decor in self.map.decors: self.spriteList.append(decor)
        
        # chargement des elements de jeux
        self.ennemies = pygame.sprite.Group()
        self.bonus= pygame.sprite.Group()

        #self.decors=pygame.sprite.Group()
        
        #decor=decors.Plateforme(60+self.offsetx,600+self.offsety,100,20,self.map.tileset.tiles[2],self)        
        #self.spriteList.append(decor)
        #self.decors.add(decor)

        #decor=decors.Roche(0+self.offsetx,0+self.offsety,20,780,self.map.tileset.tiles[1],self)        
        #self.spriteList.append(decor)
        #self.decors.add(decor)

        self.player=player.player(20,600,self)
        if self.debug: print "player",self.player.screenPos,self.player.worldPos,self.mapDraw,self.player.rect
        self.spriteList.append(self.player)
        
        for j in range(len(self.map.mapCode)):
            for i in range(len(self.map.mapCode[j])):
                if self.map.mapCode[j][i] == 1:
                    #self.player=player.player(i*20+self.offsetx,j*20+self.offsety,self)
                    #self.player=player.player(i*20+self.offsetx,j*20+19+self.offsety,self)
                    #self.player=player.player(i*20,j*20+19,self)
                    if self.debug: print "player",self.player.screenPos,self.player.worldPos,self.mapDraw,self.player.rect
                    #self.spriteList.append(self.player)
                if self.map.mapCode[j][i] == 16:
                    #ennemy=ennemies.ForestWalker1(i*20+self.offsetx,j*20+self.offsety,self)
                    ennemy=ennemies.ForestWalker1(i*20+self.offsetx,j*20+19+self.offsety,self)
                    self.spriteList.append(ennemy)
                    self.ennemies.add(ennemy)
                if self.map.mapCode[j][i] == 4:
                    bon=bonus.BGold(i*20+self.offsetx,j*20+self.offsety,self)
                    self.spriteList.append(bon)
                    self.bonus.add(bon)
                if self.map.mapCode[j][i] == 3:
                    bon=bonus.BSilver(i*20+self.offsetx,j*20+self.offsety,self)
                    self.spriteList.append(bon)
                    self.bonus.add(bon)
                if self.map.mapCode[j][i] == 2:
                    bon=bonus.BIron(i*20+self.offsetx,j*20+self.offsety,self)
                    self.spriteList.append(bon)
                    self.bonus.add(bon)

        #self.gameSprites = pygame.sprite.Group()
        #for s in self.spriteList: self.gameSprites.add(s)

    def display(self,screen):
        screen.blit(self.background,(self.offsetx,self.offsety))

    def refresh(self,screen):
        # On remet a zero les zones contenant des sprites
        #for s in spriteList:
        #    screen.blit(self.background,s.rect,s.rect)

        # Scrolling
        self.background.fill((255,255,255))

        mapx = int(self.mapDraw.x) / self.renderWidth
        mapy = int(self.mapDraw.y) / self.renderHeight
        mapOffx = int(self.mapDraw.x) % self.renderWidth
        mapOffy = int(self.mapDraw.y) % self.renderHeight
        if self.debug: print mapx,mapy,mapOffx,mapOffy

        # on utilise plutot les objets Roche
        for j in range(39):
            for i in range(52):
                if self.debug: print int(self.mapPos.x)+i,int(self.mapPos.y)+j,i*self.renderWidth,j*self.renderHeight,self.map.mapData[int(self.mapPos.y)+j][int(self.mapPos.x)+i]
                #self.background.blit(self.map.tileset.tiles[self.map.mapData[mapy+j][mapx+i]],(i*self.renderWidth-mapOffx,j*self.renderHeight-mapOffy))
        for s in self.map.decors: self.background.blit(s.displayFrame(),s.rect)
        screen.blit(self.background,(self.offsetx,self.offsety))
        
        # On deplace les sprites
        for s in self.spriteList:
            s.act()
            s.move()

        # On affiche les sprites
        for s in self.spriteList: screen.blit(s.displayFrame(),(s.rect.left+self.offsetx,s.rect.top+self.offsety))

    def move(self,spr):
        spr.worldPos=spr.screenPos+self.mapDraw
        if spr.debug: print spr.screenPos,spr.worldPos,self.mapDraw
        spr.rect.left=int(spr.screenPos.x)
        spr.rect.top=int(spr.screenPos.y+self.offset)
        if self.debug: print "move",spr.rect.left,spr.rect.top,spr.screenPos,self.factorH,self.factorV,self.offset

    def detectCollision(self,movement,player):
        tmpMovement=movement.copy()
        if self.debug: print "start",movement,tmpMovement,player.screenPos,self.mapDraw        
        if 0: # mouvement vers le bas
            boundPosy=player.worldPos.y+self.renderHeight+movement.y
            boundPosx=player.worldPos.x
            boundPosx2=player.worldPos.x+self.renderWidth-1
            boundMapPosy=int(boundPosy)/self.renderHeight
            boundMapPosx=int(boundPosx)/self.renderWidth
            boundMapPosx2=int(boundPosx2)/self.renderWidth
            player.grounded=False # mouvement vers le bas donc on est en train de tombe sauf si on touche un sol
            if 1: print player.worldPos,movement.y,boundPosx,boundPosy,boundMapPosx,boundMapPosy
            if self.map.boundMapData[boundMapPosy][boundMapPosx]&1 or self.map.boundMapData[boundMapPosy][boundMapPosx2]&1:
                tmpMovement.y = movement.y-int(boundPosy)%self.renderHeight
                player.speed.y = 0.
                if player.jumping: player.thrust = 0.
                player.jumping=False
                player.jumpTime=0
                player.grounded=True
        if movement.y > 0: # mouvement vers le bas
            boundPosy=player.rect.bottom+movement.y
            boundPosx=player.worldPos.x
            boundPosx2=player.worldPos.x+self.renderWidth-1
            boundMapPosy=int(boundPosy)/self.renderHeight
            boundMapPosx=int(boundPosx)/self.renderWidth
            boundMapPosx2=int(boundPosx2)/self.renderWidth
            player.grounded=False # mouvement vers le bas donc on est en train de tombe sauf si on touche un sol
            if self.debug: print player.worldPos,movement.y,boundPosx,boundPosy,boundMapPosx,boundMapPosy
            if self.map.boundMapData[boundMapPosy][boundMapPosx]&1 or self.map.boundMapData[boundMapPosy][boundMapPosx2]&1:
                #tmpMovement.y = movement.y-int(boundPosy)%self.renderHeight
                tmpMovement.y=float(boundMapPosy)*self.renderHeight-player.rect.bottom
                player.speed.y = 0.
                if player.jumping: player.thrust = 0.
                player.jumping=False
                player.jumpTime=0
                player.grounded=True
                #print "grounded"
        if movement.x > 0: # mouvement vers la droitee
            boundPosx=player.worldPos.x+self.renderWidth+movement.x
            boundPosy=player.worldPos.y
            boundPosy2=player.worldPos.y+self.renderHeight-1
            boundMapPosx=int(boundPosx)/self.renderWidth
            boundMapPosy=int(boundPosy)/self.renderHeight
            boundMapPosy2=int(boundPosy2)/self.renderHeight
            if self.debug: print "bound",player.worldPos,movement.x,boundPosx,boundPosy,boundMapPosx,boundMapPosy
            if self.map.boundMapData[boundMapPosy][boundMapPosx]&2 or self.map.boundMapData[boundMapPosy2][boundMapPosx]&2:
                tmpMovement.x = movement.x-int(boundPosx)%self.renderWidth
                player.speed.x = 0.
        if movement.x < 0: # mouvement vers la gauche
            boundPosx=player.worldPos.x+movement.x
            boundPosy=player.worldPos.y
            boundPosy2=player.worldPos.y+self.renderHeight-1
            boundMapPosx=int(boundPosx)/self.renderWidth
            boundMapPosy=int(boundPosy)/self.renderHeight
            boundMapPosy2=int(boundPosy2)/self.renderHeight
            if self.debug: print "bound",player.worldPos,movement.x,boundPosx,boundPosy,boundMapPosx,boundMapPosy
            if self.map.boundMapData[boundMapPosy][boundMapPosx]&8 or self.map.boundMapData[boundMapPosy2][boundMapPosx]&8:
                tmpMovement.x = movement.x+self.renderWidth-int(boundPosx)%self.renderWidth
                player.speed.x = 0.
        if (player.screenPos.x + tmpMovement.x) > (self.width-300*self.factorH) and self.mapDraw.x < (self.map.mapWidth-33)*self.renderWidth:
            self.mapDraw.x=self.mapDraw.x+((player.screenPos.x + tmpMovement.x)-(self.width-300*self.factorH))
            tmpMovement.x=((self.width-300*self.factorH)-player.screenPos.x)
        if (player.screenPos.x + tmpMovement.x) < (300*self.factorH) and self.mapDraw.x > 0:
            self.mapDraw.x=self.mapDraw.x+((player.screenPos.x + tmpMovement.x)-(300*self.factorH))
            tmpMovement.x=((300*self.factorH)-player.screenPos.x)
        if (player.screenPos.x + tmpMovement.x) < 0:
            player.screenPos.x=0.
            tmpMovement.x=0.
        if (player.screenPos.x + self.renderWidth + tmpMovement.x) > self.width:
            player.screenPos.x=float(self.width- self.renderWidth)
            tmpMovement.x=0.
        if self.debug: print "total",movement,tmpMovement,player.screenPos,self.mapDraw
        lstColEnnemy=pygame.sprite.spritecollide(player, self.ennemies, False)
        lstColBonus=pygame.sprite.spritecollide(player, self.bonus, False)
        lstColDecor=pygame.sprite.spritecollide(player, self.map.decors, False)

        if lstColEnnemy:
            for e in lstColEnnemy:
                player.hit()
        
        if lstColBonus:
            for b in lstColBonus:
                player.collect(b)
                yumenokaze.deleteFromList(b,self.spriteList)
                self.bonus.remove(b)

        return tmpMovement

    def detectCollision2(self,movement,player):
        tmpMovement=movement.copy()
        if self.debug: print "player",self.player.screenPos,self.player.worldPos,self.mapDraw,self.player.rect

        # boite de collision englobe position de depart et position potentielle de fin
        self.playercollide.rect=pygame.Rect(player.rect)

        # si on bouge la boite de collision grandit 
        self.playercollide.rect.width += movement.x
        # la droite grandit par la droite
        if movement.x < 0:
            self.playercollide.rect.left += movement.x

        # si on bouge la boite de collision grandit 
        self.playercollide.rect.height += round(movement.y)
        # la droite grandit par la droite
        if movement.y < 0:
            self.playercollide.rect.top += round(movement.y)
        
            
        lstColDecor=pygame.sprite.spritecollide(self.playercollide, self.map.decors, False)
        #print lstColDecor
        #print player.rect.bottom,movement.y

        for decor in lstColDecor:
            #print player.rect.bottom,decor.rect.top,movement.y,tmpMovement.y,player.grounded,player.jumping
            if (movement.y > 0) and (decor.boundType & 1) and (decor.rect.top >= (player.rect.bottom-1)):
                tmpMovement.y = decor.rect.top - player.rect.bottom - 0.
                if tmpMovement.y <= .5: tmpMovement.y=0.
                player.speed.y = 0.
                #if player.jumping: player.thrust = 0.
                player.jumping=False
                player.jumpTime=0
                player.grounded=True
                #print "grounded"
                #print "g:",player.rect.bottom,decor.rect.top,movement.y,tmpMovement.y,player.grounded,player.jumping
                #sys.exit()

            if (movement.x > 0) and (decor.boundType & 2) and (decor.rect.left >= (player.rect.right-1)):
                tmpMovement.x = decor.rect.left - player.rect.right - 0.
                if tmpMovement.x <= .5: tmpMovement.x=0.
                player.speed.x = 0.
                #print "grounded"
                #print "g:",player.rect.bottom,decor.rect.top,movement.y,tmpMovement.y,player.grounded,player.jumping
                #sys.exit()

            if (movement.x < 0) and (decor.boundType & 8) and (decor.rect.right <= (player.rect.left+1)):
                tmpMovement.x = decor.rect.right - player.rect.left - 0.
                if tmpMovement.x >= -0.5: tmpMovement.x=0.
                player.speed.x = 0.
                #print "grounded"
                #print "g:",player.rect.bottom,decor.rect.top,movement.y,tmpMovement.y,player.grounded,player.jumping
                #sys.exit()

        return tmpMovement
                


            

