#! /usr/bin/env python

import os, sys
import pygame
from pygame.locals import *

def groupintercollide(group, dokill):
    crashed = []
    subgroup = group.copy()
    for s in group.sprites():
        subgroup.remove(s)
        s.crash=0
        s.crashed=0
        for sp in subgroup.sprites():
            sp.crashed=0
            if s.rect.colliderect(sp.rect):
                s.crash=1
                for c in crashed:
                    if c == sp : sp.crashed=1
                    if c == s: s.crashed=1
                if sp.crashed != 1 : crashed.append(sp)
        if (s.crash == 1) and (s.crashed != 1) : crashed.append(s)
        if len(subgroup) == 1 : break
    if dokill:
        for cr in crashed: cr.kill()
    return crashed

def belongList(object, list):
    i = 0
    indexes = []
    for obj in list:
        if obj == object:
            indexes.append(i)
        i = i + 1
    return indexes

def deleteFromList(object, list):
    for i in belongList(object, list):
        del list[i]

def load_image(name, subdir=None, colorkey=None):
    if subdir is not None:
        fullname = os.path.join('data', subdir)
        fullname = os.path.join(fullname, name)
    else:
        fullname = os.path.join('data', name)
    try:
        image = pygame.image.load(fullname)
    except pygame.error, message:
        print 'Cannot load image:', fullname
        raise SystemExit, message
    image = image.convert()
    if colorkey is not None:
        if colorkey is -1:
            colorkey = image.get_at((0,0))
        image.set_colorkey(colorkey, RLEACCEL)
    return image
